<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="xml"
              encoding="utf-8"
              indent="yes"
              xslt:indent-amount="2" xmlns:xslt="http://xml.apache.org/xslt" />

  <xsl:strip-space elements="*"/>

  <!-- this is a parameter set in the XSL Policy config -->
  <xsl:param name="base_location" select="''"/>

  <xsl:template match="/">
    <xsl:comment><xsl:value-of select='concat(" base_location: ",$base_location," ")'/></xsl:comment>
    <xsl:text>&#xa;</xsl:text>
    <root>
    <!-- Elaborate each procedure -->
      <xsl:apply-templates select="root/procedures/procedureId" />
    </root>
  </xsl:template>


  <xsl:template match='procedureId'>
    <xsl:variable name="location" select="concat($base_location, normalize-space(./text()))"/>
    <!-- the following retrieves the remote document into a variable
         available to the stylesheet -->
    <xsl:variable name="xdoc" select="document($location)"/>
    <xsl:text>&#xa;</xsl:text>
    <xsl:comment><xsl:value-of select='concat(" ",$location," ")'/></xsl:comment>
    <xsl:text>&#xa;</xsl:text>
    <xsl:apply-templates select="$xdoc/root/procedureDetails"/>
  </xsl:template>

  <!-- the following two templates transform the output of the API-2 -->
  <xsl:template match='procedureDetails'>
    <procedure>
      <id><xsl:value-of select='procedureId'/></id>
      <xsl:apply-templates select="Detail"/>
    </procedure>
  </xsl:template>

  <xsl:template match='Detail'>
    <xsl:variable name="eltname" select="translate(DetailType/text(),' ','_')"/>
    <xsl:element name='{$eltname}'>
      <xsl:value-of select='value'/>
    </xsl:element>
  </xsl:template>

</xsl:stylesheet>
